import { JSX } from 'solid-js';
import { Queries, queries, BoundFunctions, prettyFormat } from '@testing-library/dom';
export * from '@testing-library/dom';

declare type Ui = () => JSX.Element;
interface Options {
    container?: HTMLElement;
    baseElement?: HTMLElement;
    queries?: Queries & typeof queries;
    hydrate?: boolean;
}
declare type DebugFn = (baseElement?: HTMLElement | HTMLElement[], maxLength?: number, options?: prettyFormat.OptionsReceived) => void;
declare type Result = BoundFunctions<typeof queries> & {
    container: HTMLElement;
    baseElement: HTMLElement;
    debug: DebugFn;
    unmount: () => void;
};

declare function render(ui: Ui, options?: Options): Result;
declare function cleanup(): void;

export { cleanup, render };
